=== Makefile ===
all:
	@echo "making third party libs"
	cd libcvd && make
	cd gvars3 && make
	cd TooN && make


clean:
	@echo "cleaning up third party libs"
	cd libcvd && make clean  
	cd gvars3 && make clean 

eclipse-project:
	@echo "skip thirdparty."
