=== TooN/Makefile ===
all: TooN_built

TooN_built: 

	cd include/TooN && ./configure && make CXXFLAGS+=-fpermissive
