=== debian/changelog ===
ros-indigo-uga-tum-ardrone (0.0.2-0trusty) trusty; urgency=high

  * Depend on GLUT, blas, and OpenGL to fix PTAM build errors
  * Contributors: Kenneth Bogert

 -- Kenneth Bogert <kbogert@uga.edu>  Sat, 12 Dec 2015 05:00:00 -0000
