=== debian/control ===
Source: ros-indigo-uga-tum-ardrone
Section: misc
Priority: extra
Maintainer: Kenneth Bogert <kbogert@uga.edu>
Build-Depends: debhelper (>= 9.0.0), freeglut3-dev, libatlas-base-dev, libblas-dev, libgl1-mesa-dev, libglu1-mesa-dev, liblapack-dev, libqt4-dev, ros-indigo-ardrone-autonomy, ros-indigo-catkin, ros-indigo-cv-bridge, ros-indigo-dynamic-reconfigure, ros-indigo-geometry-msgs, ros-indigo-message-generation, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs
Homepage: 
Standards-Version: 3.9.2

Package: ros-indigo-uga-tum-ardrone
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, freeglut3-dev, libatlas-base-dev, libblas-dev, libgl1-mesa-dev, libglu1-mesa-dev, liblapack-dev, libqt4-dev, ros-indigo-ardrone-autonomy, ros-indigo-cv-bridge, ros-indigo-dynamic-reconfigure, ros-indigo-geometry-msgs, ros-indigo-message-runtime, ros-indigo-roscpp, ros-indigo-rospy, ros-indigo-sensor-msgs, ros-indigo-std-msgs, ros-indigo-std-srvs
Description: The uga_tum_ardrone package
